GETGROUPLIST(3)

NAME
getgrouplist - calculate group access list

LIBRARY
libc

SYNOPSIS
#include <unistd.h>
int
getgrouplist(const char *name, gid_t basegid, gid_t *groups, int *ngroups);

DESCRIPTION
The getgrouplist() function reads through the group database and calculates the group access list for the user specified in name. The basegid is automatically included in the groups list. Typically this value is given as the group number from the password database.

The resulting group list is returned in the integer array pointed to by groups. The caller specifies the size of the groups array in the integer pointed to by ngroups; the actual number of groups found is returned in ngroups.

Duplicate group ids will be suppressed from the result.

RETURN VALUES
The getgrouplist() function returns -1 if the size of the group list is too small to hold all the user's groups. Here, the group array will be filled with as many groups as will fit.

FILES
/etc/group
    group membership list

SEE ALSO
setgroups(2), initgroups(3)

HISTORY
The getgrouplist() function first appeared in 4.4BSD.

BUGS
The getgrouplist() function uses the routines based on getgrent(3). If the invoking program uses any of these routines, the group structure will be overwritten in the call to getgrouplist().

In the case where the group array is too small and duplicate gids have been suppressed, the returned ngroups will be too large by a factor of the difference between the given size and the number of matches. This is not considered to be a major problem, since it's still going to be a smaller figure than when duplicates were not suppressed.